/*  Time-stamp: <18 Oct 2002 11:17 BST clapack.h maising> */

#ifndef __CLAPACK_H
#define __CLAPACK_H

#ifndef NO_F2C
#include <f2c.h>
#else

typedef double doublereal;

#endif

#ifdef AIX
#define CDLAMCH dlamch
#define CDTRTRS cdtrtrs
#define CDPOTRF cdpotrf
#define CDPPTRF cdpptrf
#define CDSYGV cdsygv
#define CDSYGVD cdsygvd
#define CDSYGVX cdsygvx
#define CDSYGST cdsygst
#define CDSPGV cdspgv
#define CDSPGVD cdspgvd
#define CDSPGVX cdspgvx
#define CDGESDD cdgesdd
#define CDGESVD cdgesvd
#define CDSYEV cdsyev
#define CDSYEVD cdsyevd
#define CDSYEVX cdsyevx
#define CDSYEVR cdsyevr

#else

#define CDLAMCH dlamch_
#define CDTRTRS cdtrtrs_
#define CDPOTRF cdpotrf_
#define CDPPTRF cdpptrf_
#define CDPOTRS cdpotrs_
#define CDSYGV cdsygv_
#define CDSYGVD cdsygvd_
#define CDSYGVX cdsygvx_
#define CDSYGST cdsygst_
#define CDSPGV cdspgv_
#define CDSPGVD cdspgvd_
#define CDSPGVX cdspgvx_
#define CDGESDD cdgesdd_
#define CDGESVD cdgesvd_
#define CDSYEV cdsyev_
#define CDSYEVD cdsyevd_
#define CDSYEVX cdsyevx_
#define CDSYEVR cdsyevr_

#endif

extern int CDLAMCH(char *);
extern int CDTRTRS(int *UPLO2, int *TRANS2, int *DIAG2, int *N, int *NRHS, 
		   doublereal *A, int *LDA, doublereal *B, int *LDB,
		   int *INFO);
/* Cholesky decomposition */
extern int CDPOTRF(int *UPLO2, int *N, doublereal *A, int *LDA, int *INFO);
extern int CDPPTRF(int *UPLO2, int *N, doublereal *AP, int *INFO );
/* linear equations using Cholesky decomposition */
extern int CDPOTRS(int *UPLO2, int *N, int *NRHS, doublereal *A, int *LDA, 
		   doublereal *B, int *LDB, int *INFO);

/* generalised EV */
extern int CDSPGV(int *ITYPE, int *JOBZ2, int *UPLO2, int *N, 
		   doublereal *AP, doublereal *BP, doublereal *W, 
		   doublereal *Z, int *LDZ, doublereal *WORK, int *INFO );
extern int CDSPGVD(int *ITYPE, int *JOBZ2, int *UPLO2, int *N, 
		   doublereal *AP, doublereal *BP, doublereal *W, 
		   doublereal *Z, int *LDZ, doublereal *WORK,
		   int *LWORK, int *IWORK, int *LIWORK, int *INFO );
extern int CDSPGVX(int *ITYPE, int *JOBZ2, int *RANGE2, int *UPLO2, int *N, 
		   doublereal *AP, doublereal *BP, 
		   doublereal *VL, doublereal *VU, int *IL, int *IU, 
		   doublereal *ABSTOL, int *M, doublereal *W, 
		   doublereal *Z, int *LDZ, doublereal *WORK, int *IWORK, 
		   int *IFAIL, int *INFO);
extern int CDSYGV(int *ITYPE, int *JOBZ2, int *UPLO2, int *N, doublereal *A, 
		  int *LDA, doublereal *B, int *LDB, doublereal *W,
		  doublereal *WORK, int *LWORK, int *INFO);
extern int CDSYGVD(int *ITYPE, int *JOBZ2, int *UPLO2, int *N, doublereal *A, 
		   int *LDA, doublereal *B, int *LDB, doublereal *W,
		   doublereal *WORK, int *LWORK, int *IWORK, int *LIWORK, 
		   int *INFO);
extern int CDSYGVX(int *ITYPE, int *JOBZ2, int *RANGE2, int *UPLO2, int *N, 
		   doublereal *A, int *LDA, doublereal *B, int *LDB,
		   doublereal *VL, doublereal *VU, int *IL, int *IU, 
		   doublereal *ABSTOL, int *M, doublereal *W, doublereal *Z, 
		   int *LDZ, doublereal *WORK, int *LWORK, int *IWORK, 
		   int *IFAIL, int *INFO);
extern int CDSYGST(int *ITYPE, int *UPLO2, int *N, doublereal *A, int *LDA, 
		   doublereal *B, int *LDB, int *INFO);
/* SVD */
extern int CDGESVD(int *JOBU2, int *JOBVT2, int *M, int *N, 
		   doublereal *A, int *LDA, doublereal *S, doublereal *U, 
		   int *LDU, doublereal *VT, int *LDVT, doublereal *WORK, 
		   int *LWORK, int *INFO);
extern int CDGESDD(int *JOBZ2, int *M, int *N, doublereal *A, int *LDA, 
		   doublereal *S, doublereal *U, int *LDU, doublereal *VT, 
		   int *LDVT, doublereal *WORK, int *LWORK, int *IWORK, 
		   int *INFO);
/* symmetric EV */
extern int CDSYEV( int *JOBZ2, int *UPLO2, int *N, doublereal *A, 
		   int *LDA, doublereal *W, doublereal *WORK, 
		   int *LWORK, int *INFO );
extern int CDSYEVD( int *JOBZ2, int *UPLO2, int *N, doublereal *A, int *LDA, 
		    doublereal *W, doublereal *WORK, int *LWORK,
		    int *IWORK, int *LIWORK, int *INFO );
extern int CDSYEVX( int *JOBZ2, int *RANGE2, int *UPLO2, int *N, 
		    doublereal *A, int *LDA, doublereal *VL, doublereal *VU, 
		    int *IL, int *IU, doublereal *ABSTOL, int *M, 
		    doublereal *W, doublereal *Z, int *LDZ, 
		    doublereal *WORK, int *LWORK, int *IWORK, 
		    int *IFAIL, int *INFO );
extern int CDSYEVR( int *JOBZ2, int *RANGE2, int *UPLO2, int *N, 
		    doublereal *A, int *LDA, doublereal *VL, doublereal *VU, 
		    int *IL, int *IU, doublereal *ABSTOL, int *M, 
		    doublereal *W, doublereal *Z, int *LDZ, int *ISUPPZ,
		    doublereal *WORK, int *LWORK, int *IWORK, 
		    int *LIWORK, int *INFO );
#endif
