c-----*-----------------------------------------------------------------

      real*4 function dl(l,h0,omegabh2,an,tau,omegat,lambda,dtt,scale,
     &                    r,tn)
      implicit none
      integer*4 l,i
      real*4    h0,omegabh2,an,tau,omegat,lambda,dtt,scale,r,tn
      real*4    h0copy,omegabh2copy,ancopy,taucopy,omegatcopy
      real*4    lambdacopy,dttcopy,scalecopy,rcopy,tncopy,d2cobe
      real*4    pi,rl,sig,meas,norm,value,dttm,scalem
      real*4    tnorm,d2s,d2t,sum,tiny
      real*4    dl_s,dl_t,dlnn,dlnnt

      external  dl_s,dl_t,dlnn,dlnnt

      tiny=1e-5
      if (r.lt.tiny .and. r.gt.(-tiny)) then
        dl=dl_s(l,h0,omegabh2,lambda,tau,an,omegat,dtt,scale)
        return
      else if (r.le.(-1+tiny)) then
        dl=dl_t(l,h0,omegabh2,lambda,tau,tn,omegat,dtt,scale)
        return
      end if

      if ((h0.eq.h0copy) .and.
     &    (omegabh2.eq.omegabh2copy) .and.
     &    (an.eq.ancopy) .and.
     &    (tau.eq.taucopy) .and.
     &    (omegat.eq.omegatcopy) .and.
     &    (lambda.eq.lambdacopy) .and.
     &    (scale.eq.scalecopy) .and.
     &    (r.eq.rcopy) .and.
     &    (tn.eq.tncopy)) then
        if (dtt.eq.dttcopy) then
          dl=norm*(dlnn(l,h0,omegabh2,lambda,tau,an,omegat)
     &         +tnorm*dlnnt(l,h0,omegabh2,lambda,tau,tn,omegat))
          return
        else
          dl=dtt*(norm/dttcopy)*
     &        (dlnn(l,h0,omegabh2,lambda,tau,an,omegat)
     &         +tnorm*dlnnt(l,h0,omegabh2,lambda,tau,tn,omegat))
          return
        end if
      end if

      pi=3.14159265
c measured d2 from COBE (4 yr) assuming n=1
      d2cobe=6.5748e-10
c empirical variance at 10 deg using d2cobe and n=1
      meas=1.833e-10

c fix ratio of d2 scalar and d2 tensor
      d2s=dlnn(2,h0,omegabh2,lambda,tau,an,omegat)
      d2t=r*d2s
      tnorm=d2t/dlnnt(2,h0,omegabh2,lambda,tau,tn,omegat)

      if (dtt.lt.0.0) then
        dttm=meas
      else
        dttm=dtt
      end if
      if (scale.lt.0.0) then
        scalem=10.0
      else
        scalem=scale
      end if
      sig=scalem*pi/180.0/2.35

      value=0.0
      do i=2,80
        rl=float(i)
        sum=dlnn(i,h0,omegabh2,lambda,tau,an,omegat)
     &     +tnorm*dlnnt(i,h0,omegabh2,lambda,tau,tn,omegat)
        value=value+(2.0*rl+1.0)*(sum/(rl*(rl+1.0)))
     &       *exp(-rl*(rl+1.0)*sig**2)
      end do
      value=value/(4.0*pi)
      norm=dttm/value

c      norm=d2cobe/dlnn(2,h0,omegabh2,lambda,tau,an,omegat)

      dl=norm*(dlnn(l,h0,omegabh2,lambda,tau,an,omegat)
     &         +tnorm*dlnnt(l,h0,omegabh2,lambda,tau,tn,omegat))

      h0copy=h0
      omegabh2copy=omegabh2
      ancopy=an
      taucopy=tau
      omegatcopy=omegat
      lambdacopy=lambda
      dttcopy=dtt
      scalecopy=scale
      rcopy=r
      tncopy=tn

      end

c-----*-----------------------------------------------------------------

      real*4 function dln(l,h0,omegabh2,an,tau,omegat,lambda,qrmsps,
     &                    r,tn)
      implicit none
      integer*4 l
      real*4    h0,omegabh2,an,tau,omegat,lambda,qrmsps,r,tn
      real*4    pi,tiny,tcmb,snorm,tnorm,d2,d2s,d2t
      real*4    dl_sn,dl_tn,dlnn,dlnnt

      external  dl_sn,dl_tn,dlnn,dlnnt



c if r=0 then just use scalar function
      tiny=1e-5
      if (r.lt.tiny .and. r.gt.(-tiny)) then
        dln=dl_sn(l,h0,omegabh2,lambda,tau,an,omegat,qrmsps)
        return
c if r=-1 then just use tensor function
      else if (r.le.(-1+tiny)) then
        dln=dl_tn(l,h0,omegabh2,lambda,tau,tn,omegat,qrmsps)
        return
      end if

c initialise variables
      pi=3.14159265
      tcmb=2.726
      d2=6.0*(4.0*pi/5.0)*(1.0e-6*qrmsps/tcmb)**2

c fix ratio of d2 scalar and d2 tensor
      d2s=d2/(1.0+r)
      d2t=r*d2s

c calculate normalisation
      snorm=d2s/dlnn(2,h0,omegabh2,lambda,tau,an,omegat)
      tnorm=d2t/dlnnt(2,h0,omegabh2,lambda,tau,tn,omegat)

      dln=snorm*dlnn(l,h0,omegabh2,lambda,tau,an,omegat)
     &   +tnorm*dlnnt(l,h0,omegabh2,lambda,tau,tn,omegat)

      end

c-----*-----------------------------------------------------------------









