c-----*-----------------------------------------------------------------

      subroutine read_dls
      implicit none
      integer*4 nlmax,n_h0max,n_obmax,nlambmax,ntmax,nnmax
      parameter (nlmax=45,n_h0max=13,n_obmax=11,nlambmax=8,ntmax=6,
     &           nnmax=9)
      real*4    dlarr(nlmax*nnmax*ntmax*nlambmax*n_obmax*n_h0max)
      integer*4 nl,n_h0,n_omegabh2,n_lambda,n_tau,nn
      integer*4 il(nlmax),lm,lind,lvar
      real*4    h0min,h0step,omegabh2min,omegabh2step,anmin,anstep
      real*4    taumin,taustep,lambdamin,lambdastep
      character*60 dlfile
 
      common /ls/ il
      common /dls/ dlarr
      common /arcord/ h0min,h0step,omegabh2min,omegabh2step,
     &                lambdamin,lambdastep,taumin,taustep,anmin,anstep
      common /ardim/ nl,n_h0,n_omegabh2,n_lambda,n_tau,nn

c      write(*,100)
c 100  format(' Enter scalar dl file name: ',$)
c      read(*,'(a)') dlfile
c      dlfile='/mraos/data/mph/'//dlfile
      dlfile='/mraos/data/mph/dlfilesn.dat'
      open(unit=9,file=dlfile,form='unformatted',status='unknown')
      rewind(9)

      read(9) lm,nl
      read(9) h0min,h0step,n_h0
      read(9) omegabh2min,omegabh2step,n_omegabh2
      read(9) anmin,anstep,nn
      read(9) lambdamin,lambdastep,n_lambda
      read(9) taumin,taustep,n_tau
      read(9) dlarr
      close (9)

c have l's in il(j); from 2-10,12,15,20,30,40,60,80,100, every 50 beyond

      lind=1
      do lvar=2,10
        il(lind)=lvar
        lind=lind+1
      end do
      il(lind)=12
      lind=lind+1
      il(lind)=15
      lind=lind+1
      il(lind)=20
      lind=lind+1
      il(lind)=30
      lind=lind+1
      il(lind)=40
      lind=lind+1
      il(lind)=60
      lind=lind+1
      il(lind)=80
      do lvar=100,lm,50
        lind=lind+1
        il(lind)=lvar
      end do

      write(*,*)
      write(*,*) ' Scalar dl file:'
      write(*,*) ' dimensions of array = ',lind,n_h0,n_omegabh2,
     &                                     n_lambda,n_tau,nn
      write(*,*) ' lmax and number of l = ',lm,nl
      write(*,*) ' H0 min, max and step = ',h0min,
     &             h0min+float(n_h0-1)*h0step,h0step
      write(*,*) ' Omega_b h^2 min, max and step = ',omegabh2min,
     &             omegabh2min+float(n_omegabh2-1)*omegabh2step,
     &             omegabh2step
      write(*,*) ' lambda min, max and step = ',lambdamin,
     &             lambdamin+float(n_lambda-1)*lambdastep,lambdastep
      write(*,*) ' tau min, max and step = ',taumin,
     &             taumin+float(n_tau-1)*taustep,taustep
      write(*,*) ' n min, max and step = ',anmin,
     &             anmin+float(nn-1)*anstep,anstep
      write(*,*)

      end

c-----*-----------------------------------------------------------------

      subroutine gridpos(h0,omegabh2,lambda,tau,an,ih0,iomegabh2,
     &                   ilambda,itau,ian)
      implicit none
      real*4    h0,omegabh2,lambda,tau,an
      integer*4 ih0,iomegabh2,ilambda,itau,ian
      real*4    h0min,h0step,omegabh2min,omegabh2step
      real*4    lambdamin,lambdastep,taumin,taustep,anmin,anstep
      real*4    tiny

      common /arcord/ h0min,h0step,omegabh2min,omegabh2step,
     &                lambdamin,lambdastep,taumin,taustep,anmin,anstep

      tiny=1.0e-5

      ih0=int((h0-h0min)/h0step+tiny)+1
      iomegabh2=int((omegabh2-omegabh2min)/omegabh2step+tiny)+1
      ilambda=int((lambda-lambdamin)/lambdastep+tiny)+1
      itau=int((tau-taumin)/taustep+tiny)+1
      ian=int((an-anmin)/anstep+tiny)+1

      end

c-----*-----------------------------------------------------------------

      real*4 function dlflat(l,h0,omegabh2,lambda,tau,an)

      implicit none
      integer*4 l
      real*4    h0,omegabh2,lambda,tau,an
      integer*4 nlmax
      parameter (nlmax=45)
      real*4    val,xl
      real*4    h0copy,omegabh2copy,lambdacopy,taucopy,ancopy
      integer*4 il(nlmax),i
      integer*4 ih0,iomegabh2,ilambda,itau,ian
      integer*4 nl,n_h0,n_omegabh2,n_lambda,n_tau,nn
      real*4    x(nlmax),y(nlmax),y2(nlmax),yp1,ypn

      common /ls/ il
      common /ardim/ nl,n_h0,n_omegabh2,n_lambda,n_tau,nn

      if (l.lt.il(1) .or. l.gt.il(nl)) then
        dlflat=0.
        return
      end if       

      xl=float(l)

      if ((h0.eq.h0copy) .and.
     &    (omegabh2.eq.omegabh2copy) .and.
     &    (lambda.eq.lambdacopy) .and.
     &    (tau.eq.taucopy) .and.
     &    (an.eq.ancopy)) then
        call splint(x,y,y2,nl,xl,val)
        dlflat=val
        return
      end if

      call gridpos(h0,omegabh2,lambda,tau,an,ih0,iomegabh2,
     &             ilambda,itau,ian)
      do i=1,nl
        call intdls(i,ih0,iomegabh2,ilambda,itau,ian,h0,omegabh2,lambda,
     &              tau,an,val)      
        x(i)=float(il(i))
        y(i)=val
        y2(i)=0.
      end do

      yp1=1e30
      ypn=1e30
      call spline(x,y,nl,yp1,ypn,y2)
      call splint(x,y,y2,nl,xl,val)

      dlflat=val

      h0copy=h0
      omegabh2copy=omegabh2
      lambdacopy=lambda
      taucopy=tau
      ancopy=an

      end

c-----*-----------------------------------------------------------------

      real*4 function dlnn(l,h0,omegabh2,lambda,tau,an,omegat)
      implicit none
      integer*4 l
      real*4    h0,omegabh2,lambda,tau,an,omegat
      real*4    h0new,tiny
      real*4    pi,lshift,lcurv,gomega,fact,t,arg
      real*4    dlflat

      external  dlflat

      pi=3.14159265
      tiny=1e-5

c if omegat=1 (flat universe) then use dlflat
      if (omegat.gt.(1.0-tiny) .and. omegat.lt.(1.0+tiny)) then
        dlnn=dlflat(l,h0,omegabh2,lambda,tau,an)
        return
      end if

c change h0 to keep Omega_t h0**2 constant
      h0new=h0*sqrt(omegat)

c shift dl spectrum (but no shift for first few multipoles)
      if (l.le.4) then
        dlnn=dlflat(l,h0new,omegabh2,lambda,tau,an)
        goto 100
      end if

      lshift=float(l)*omegat**0.5
      t=lshift-float(int(lshift))
      dlnn=0.0
      dlnn=dlnn+(1.0-t)*dlflat(int(lshift),h0new,omegabh2,lambda,tau,an)
      dlnn=dlnn+t*dlflat(int(lshift)+1,h0new,omegabh2,lambda,tau,an)

c calculate multiplicative omegat correction factor
 100  continue
      if (omegat.lt.(1.0-tiny)) then
        lcurv=pi*((1.0-omegat)/omegat)**0.5
        gomega=4.5*((1.0-omegat)/omegat)**0.817
        arg=0.3*float(l)/lcurv
        if (arg.lt.35.) then
          fact=1.0+exp(-arg)*gomega/(float(l)+0.5)
        else
          fact=1.0
        end if
      else
        fact=1.0
      end if

c apply omegat scaling corrections

      dlnn=dlnn*fact

      end

c-----*-----------------------------------------------------------------

      real*4 function dl_s(l,h0,omegabh2,lambda,tau,an,omegat,dtt,scale)
      implicit none
      integer*4 l,i
      real*4    h0,omegabh2,lambda,tau,an,omegat,dtt,scale
      real*4    h0copy,omegabh2copy,lambdacopy,taucopy,ancopy
      real*4    omegatcopy,dttcopy,scalecopy,d2cobe
      real*4    pi,rl,sig,meas,norm,value,dttm,scalem
      real*4    dlnn

      external  dlnn

c if parameters same as last time, then use previous value of norm

      if ((h0.eq.h0copy) .and.
     &    (omegabh2.eq.omegabh2copy) .and.
     &    (lambda.eq.lambdacopy) .and.
     &    (tau.eq.taucopy) .and.
     &    (an.eq.ancopy) .and.
     &    (omegat.eq.omegatcopy) .and.
     &    (scale.eq.scalecopy)) then
        if (dtt.eq.dttcopy) then
          dl_s=norm*dlnn(l,h0,omegabh2,lambda,tau,an,omegat)
          return
        else
          dl_s=dtt*(norm/dttcopy)
     &       *dlnn(l,h0,omegabh2,lambda,tau,an,omegat)
          return
        end if
      end if

c initialise data

      pi=3.14159265
      meas=1.833e-10         ! COBE 10 degree (dT/T)_rms
      d2cobe=6.5748e-10      ! COBE d_2 value

c use (dT/T)_rms on given angular scale (degrees) to normalise spectrum 

      if (dtt.lt.0.0) then
        dttm=meas
      else
        dttm=dtt
      end if
      if (scale.lt.0.0) then
        scalem=10.0
      else
        scalem=scale
      end if
      sig=scalem*pi/180.0/2.35

      value=0.0
      do i=2,80
        rl=float(i)
        value=value+(2.0*rl+1.0)
     &       *(dlnn(i,h0,omegabh2,lambda,tau,an,omegat)/(rl*(rl+1.0)))
     &       *exp(-rl*(rl+1.0)*sig**2)
      end do
      value=value/(4.0*pi)
      norm=dttm/value

c use COBE d2 value to normalise spectrumk

c      norm=d2cobe/dlnn(2,h0,omegabh2,lambda,tau,an,omegat)

c perform normalisation

      dl_s=norm*dlnn(l,h0,omegabh2,lambda,tau,an,omegat)

c copy parameters for next time

      h0copy=h0
      omegabh2copy=omegabh2
      lambdacopy=lambda
      taucopy=tau
      ancopy=an
      omegatcopy=omegat
      dttcopy=dtt
      scalecopy=scale

      end

c-----*-----------------------------------------------------------------

      real*4 function dl_sn(l,h0,omegabh2,lambda,tau,an,omegat,qrmsps)
      implicit none
      integer*4 l
      real*4    h0,omegabh2,lambda,tau,an,omegat,qrmsps
      real*4    norm,pi,tcmb,d2
      real*4    dlnn

      external  dlnn


c perform normalisation

      pi=3.14159265
      tcmb=2.726
      d2=6.0*(4.0*pi/5.0)*(1.0e-6*qrmsps/tcmb)**2

      norm=d2/dlnn(2,h0,omegabh2,lambda,tau,an,omegat)
      dl_sn=norm*dlnn(l,h0,omegabh2,lambda,tau,an,omegat)

      end

c-----*-----------------------------------------------------------------

      subroutine intdls(l,ih0,iomegabh2,ilambda,itau,ian,h0,omegabh2,
     &                  lambda,tau,an,val)
      implicit none
      integer*4 l
      integer*4 nlmax,n_h0max,n_obmax,nlambmax,ntmax,nnmax
      parameter (nlmax=45,n_h0max=13,n_obmax=11,nlambmax=8,ntmax=6,
     &           nnmax=9)
      real*4    dlarr(nlmax*nnmax*ntmax*nlambmax*n_obmax*n_h0max)
      real*4    h0,omegabh2,lambda,tau,an
      integer*4 ih0,iomegabh2,ilambda,itau,ian
      integer*4 ii,jj,kk,ll,mm,index,ind
      integer*4 nl,n_h0,n_omegabh2,n_lambda,n_tau,nn
      real*4    h0min,h0step,omegabh2min,omegabh2step
      real*4    lambdamin,lambdastep,taumin,taustep,anmin,anstep
      real*4    val,t,u,v,w,x,tnew,unew,vnew,wnew,xnew
      real*4    h01,h02,omegabh21,omegabh22,lambda1,lambda2,tau1,tau2
      real*4    an1,an2
 
      external  index

      common /dls/ dlarr
      common /arcord/ h0min,h0step,omegabh2min,omegabh2step,
     &                lambdamin,lambdastep,taumin,taustep,anmin,anstep
      common /ardim/ nl,n_h0,n_omegabh2,n_lambda,n_tau,nn

      if ((ih0.gt.n_h0 .or. ih0.lt.1) .or.
     &    (iomegabh2.gt.n_omegabh2 .or. iomegabh2.lt.1) .or. 
     &    (ilambda.gt.n_lambda .or. ilambda.lt.1) .or.
     &    (itau.gt.n_tau .or. itau.lt.1) .or.
     &    (ian.gt.nn .or. ian.lt.1)) then
        write(*,*) ' WARNING: required parameters lie outside grid'
        val=0.0
        return
      end if

c      if (omegabh2.lt.0.009 .or. omegabh2.gt.0.02)
c     &write(*,*) ' WARNING: Omega_b h^2 outside nucleosynthesis bounds'

      h01=h0min+float(ih0-1)*h0step
      h02=h01+h0step
      omegabh21=omegabh2min+float(iomegabh2-1)*omegabh2step
      omegabh22=omegabh21+omegabh2step
      an1=anmin+float(ian-1)*anstep
      an2=an1+anstep
      lambda1=lambdamin+float(ilambda-1)*lambdastep
      lambda2=lambda1+lambdastep
      tau1=taumin+float(itau-1)*taustep
      tau2=tau1+taustep
      an1=anmin+float(ian-1)*anstep
      an2=an1+anstep
      
      t=(h0-h01)/(h02-h01)
      u=(omegabh2-omegabh21)/(omegabh22-omegabh21)
      v=(lambda-lambda1)/(lambda2-lambda1)
      w=(tau-tau1)/(tau2-tau1)
      x=(an-an1)/(an2-an1)

      if ((t.eq.0.).and.(u.eq.0).and.(v.eq.0).and.(w.eq.0.)
     &    .and.(x.eq.0)) then
        ind=index(l,ih0,iomegabh2,ilambda,itau,ian)
        val=dlarr(ind)
        return
      end if

      val=0.0
      do ii=0,1
        do jj=0,1
          do kk=0,1
            do ll=0,1
              do mm=0,1
                tnew=(2.0*t-1.0)*float(ii)+(1.0-t)
                unew=(2.0*u-1.0)*float(jj)+(1.0-u)
                vnew=(2.0*v-1.0)*float(kk)+(1.0-v)
                wnew=(2.0*w-1.0)*float(ll)+(1.0-w)
                xnew=(2.0*x-1.0)*float(mm)+(1.0-x)
                ind=index(l,ih0+ii,iomegabh2+jj,ilambda+kk,itau+ll,
     &                    ian+mm)
                val=val+tnew*unew*vnew*wnew*xnew*dlarr(ind)
              end do
            end do
          end do
        end do
      end do

      end

c-----*-----------------------------------------------------------------

      integer function index(l,ih0,iomegabh2,ilambda,itau,ian)
      implicit none
      integer*4 l,ih0,iomegabh2,ilambda,itau,ian
      integer*4 nl,n_h0,n_omegabh2,n_lambda,n_tau,nn

      common /ardim/ nl,n_h0,n_omegabh2,n_lambda,n_tau,nn
      
      index=(ih0-1)*n_omegabh2*n_lambda*n_tau*nn*nl
     &     +(iomegabh2-1)*n_lambda*n_tau*nn*nl
     &     +(ilambda-1)*n_tau*nn*nl
     &     +(itau-1)*nn*nl
     &     +(ian-1)*nl
     &     +l

      return
      end

c-----*-----------------------------------------------------------------









