c-----*-----------------------------------------------------------------

c program to marginalise the 4-D likelihood function and plot results
c MPH, 1995
c
c ??-??-2001 KSM  use ASCII file format instead of binary
c ??-??-2001 MPH  fix x-axis scaling bug

      program   likeplot
      implicit  none
      integer*4 n1max,n2max,n3max,n4max
      parameter (n1max=11,n2max=11,n3max=501,n4max=501)
      integer*4 npmax
      parameter (npmax=501)

      integer*4 n1,n2,n3,n4
      integer*4 i,j,k
      integer*4 i1,i2,i3,i4
      integer*4 j1,j2,j3,j4
      integer*4 i2max,i3max,i4max
      integer*4 ng(4),mg(4)
      integer*4 ndim,dims(4),flag(4),label(4)
      integer*4 plot,axes(4),index(4)
      integer*4 ivar(2),xnpts,ynpts,xaxis,yaxis,len,nint(2),npts
      integer*4 gacfax,indx,psax

      real*4    p1pts(n1max),p2pts(n2max),p3pts(n3max),p4pts(n4max)
      real*4    min(4),max(4),step(4)
      real*4    xmin,xmax,xstep,ymin,ymax,ystep,coord,tiny
      real*4    xarr(npmax),yarr(npmax),xyarr(npmax,npmax),trans(6)
      real*4    wkspc1(npmax),wkspc2(npmax)
      real*4    wkspc3(npmax,npmax),wkspc4(npmax,npmax)
      real*4    minrad,t0,centre(n1max)
      real*4    yp1,ypn,c0,theta_c,xnew,ynew,gaussps,pi,value(4)

      real*8    dum1,dum2,dum3
      real*8    arrmax
      real*8    array(n1max,n2max,n3max,n4max)
      real*8    margarr(n1max,n2max,n3max,n4max)

      character axlab(4)*40,gaxlab(2)*40,title(2)*40,infile*40,outfn*40
      character choice*1,grchoice*1,parspc*1,intyn*1,gacfyn*1
      character convert*1,jeffyn*1,hard*3

      equivalence (ng(1),n1),(ng(2),n2),(ng(3),n3),(ng(4),n4)

      external  gaussps

c initialise variables

      data axlab/'\\fil\\fr',
     &           'Flux spectral index \\ga\\fr',
     &           '\\fil\\u2\\dC\\dl\\u/2\\gp\\fr',
     &           '\\fil\\u2\\dG\\dl\\u/2\\gp\\fr'/
      data title/' ',
     &           'Relative Likelihood'/
      tiny=1e-20
      minrad=2.90888e-4
      t0=2.726
      pi=3.1415927
      do i=1,4
        flag(i)=0
      end do

c open PGPLOT

      call pgbegin(0,'?',1,1)

c open file and read in data

      write(*,'(a,$)') ' Enter filename of likelihood function: '
      read(*,'(a)') infile
      open(unit=16,form='formatted',
     &     file=infile,status='old')
      do i=1,4
        read(16,*) dum1,dum2,dum3
        min(i)=dum1
        max(i)=dum2
        ng(i)=int(dum3)
      end do
c
c ... N.B. this axis ordering matches that in VSALFCN.F & VSAEIGEN.F
c
      do i1=1,ng(1)                ! bin number
        do i2=1,ng(2)              ! GAL flux spectral index
          do i4=1,ng(4)            ! GAL power spectrum
            do i3=1,ng(3)          ! CMB power spectrum
              read(16,*) array(i1,i2,i3,i4)
            end do
          end do
        end do
      end do

      write(*,'(a,$)')' Are parameter points equally spaced (y/n)? [y] '
      read(*,'(a1)') parspc
      if (parspc.eq.'n' .or. parspc.eq.'N') then
        do i=1,ng(1)
          read(16,*) p1pts(i)
        end do
        do i=1,ng(2)
          read(16,*) p2pts(i)
        end do
        do i=1,ng(3)
          read(16,*) p3pts(i)
        end do
        do i=1,ng(4)
          read(16,*) p4pts(i)
        end do
      end if
      close(16)

c write out dimensions and limits read in

      write(*,*)
      write(*,*) 'The axis order of the 4-D array is as follows: '
      write(*,*) ' axis 1: the spectral bin'
      write(*,*) ' axis 2: spectral index of GAL'
      write(*,*) ' axis 3: power in CMB'
      write(*,*) ' axis 4: power in GAL'
      write(*,*)
      write(*,'(a,4i4)') ' Array has dimensions ',
     &  ng(1),ng(2),ng(3),ng(4)
      write(*,*)
      do i=1,4
        write(*,'(a,i2,a,2g10.4)') ' Limits on axis ',i,' are ',
     &    min(i),max(i) 
      end do

c calculate step length for each axis

      if (parspc.ne.'n' .and. parspc.ne.'N') then

        step(1)=(max(1)-min(1))/(real(ng(1)))
        do i=1,n1
          p1pts(i)=(min(1)-step(1)/2.0)+float(i)*step(1)
        end do
        do i=2,4
          if (ng(i).gt.1) then
            step(i)=(max(i)-min(i))/(real(ng(i)-1))
          else
            step(i)=0d0
          end if
        end do
        do i=1,n2
          p2pts(i)=min(2)+float(i-1)*step(2)
        end do         
        do i=1,n3
          p3pts(i)=min(3)+float(i-1)*step(3)
        end do         
        do i=1,n4
          p4pts(i)=min(4)+float(i-1)*step(4)
        end do         
      end if      

c normalise and antilog log(likehd) in each bin separately

      do i1=1,ng(1)
        arrmax=-1d20
        do i2=1,ng(2)
          do i3=1,ng(3)
            do i4=1,ng(4)
              if (array(i1,i2,i3,i4).gt.arrmax) then
                arrmax=array(i1,i2,i3,i4)
              end if
            end do
          end do
        end do
        do i2=1,ng(2)
          do i3=1,ng(3)
            do i4=1,ng(4)
              if ((array(i1,i2,i3,i4)-arrmax).gt.(-38d0)) then
                array(i1,i2,i3,i4)=dexp(array(i1,i2,i3,i4)-arrmax)
              else
                array(i1,i2,i3,i4)=0d0
              end if
            end do
          end do
        end do
      end do

c interpolate likelihood function onto (finer) regular grid

      write(*,*)
      write(*,'(a,$)')
     &  ' Interpolate PS onto (finer) regular grid (y/n)? [n] '
      read(*,'(a1)') intyn
      if (intyn.eq.'y' .or. intyn.eq.'Y') then
c ...if there is one PS axis
        if (n2.eq.1 .and. n4.eq.1) then
          write(*,'(a,$)') 
     &      ' Input no. of interpolated points on PS axis: '
          read(*,*) nint(1)        
          xmin=p3pts(1)
          xmax=p3pts(n3)
          ymin=min(3)
          ymax=max(3)
          i2=1
          i4=1
          do i1=1,n1
            do i3=1,n3
              xarr(i3)=p3pts(i3)
              yarr(i3)=real(array(i1,i2,i3,i4))
            end do
            call int1da(xarr,yarr,wkspc1,wkspc2,npmax,n3,
     &                  xmin,xmax,nint(1),step(3))
            do i3=1,nint(1)
              array(i1,i2,i3,i4)=dble(yarr(i3))
            end do
          end do
          do i=1,nint(1)
            p3pts(i)=xarr(i)
          end do
          n3=nint(1)
          write(*,'(a,4i3)') ' Array has new dimensions ',
     &      ng(1),ng(2),ng(3),ng(4)
          write(*,*)
        else
c ...if there are two PS axes
          write(*,'(a,$)')
     &      ' Input no. of interpolated points on PS axes: '
          read(*,*) (nint(i),i=1,2)        
          xmin=min(3)
          xmax=max(3)
          ymin=min(4)
          ymax=max(4)
          do i1=1,n1
            do i2=1,n2
              do i3=1,n3
                xarr(i3)=p3pts(i3)
                do i4=1,n4
                  yarr(i4)=p4pts(i4)
                  xyarr(i3,i4)=real(array(i1,i2,i3,i4))
                end do
              end do        
              call int2da(xarr,yarr,xyarr,wkspc3,wkspc4,npmax,n3,n4,
     &                    xmin,xmax,ymin,ymax,nint,step(3),step(4))
              do i3=1,nint(1)
                do i4=1,nint(2)
                  array(i1,i2,i3,i4)=dble(xyarr(i3,i4))
                end do
              end do
            end do
          end do
          do i=1,nint(1)
            p3pts(i)=xarr(i)
          end do
          do i=1,nint(2)
            p4pts(i)=yarr(i)
          end do
          n3=nint(1)
          n4=nint(2)
          write(*,'(a,4i3)') ' Array has new dimensions ',
     &      ng(1),ng(2),ng(3),ng(4)
          write(*,*)
        end if
      end if

c combine bins if required

      write(*,'(a,$)') ' Combine bins (y/n) [n]? '
      read(*,'(a1)') choice
      if (choice.eq.'y' .or. choice.eq.'Y') then
        do i2=1,n2
          do i3=1,n3
            do i4=1,n4
              dum1=1d0
              do i1=1,n1
                dum1=dum1*array(i1,i2,i3,i4)
              end do
              array(1,i2,i3,i4)=dum1
            end do
          end do
        end do
        n1=1
        do i=1,n1
          centre(i)=(min(i)+max(i))/2.0
        end do
      else
        do i=1,n1
          centre(i)=p1pts(i)
        end do
      end if
      
      write(*,*)
      write(*,*) ' Taking bin centres as ',(centre(i),i=1,n1)
      write(*,*)

c ask for further parameters

      write(*,'(a,$)') ' Are PS axes C_l (0) or l^2 C_l/2pi (1)? '
      read(*,*) psax

c multiply the likelihood function by a Jeffrey's prior on each PS

      write(*,'(a,$)') 
     &  ' Multiply likelihood by Jeffreys prior (y/n)? [n]: '
      read(*,'(a1)') jeffyn
      if (jeffyn.eq.'y' .or. jeffyn.eq.'Y') then
      do i1=1,ng(1)
        do i2=1,ng(2)
          do i3=2,ng(3)
            do i4=2,ng(4)
              value(3)=p3pts(i3)
              value(4)=p4pts(i4)
              if (psax.eq.1) then
                value(3)=2.0*pi*value(3)/(centre(i1)**2)
                value(4)=2.0*pi*value(4)/(centre(i1)**2)
              end if
              if (ng(4).le.1) value(4)=1.0
              array(i1,i2,i3,i4)=array(i1,i2,i3,i4)
     &          *(1.0/value(3))
     &          *(1.0/value(4))
            end do
          end do
        end do
      end do
      end if

c normalise each bin to unity at peak

      do i1=1,ng(1)
        call norm2(array,n1max,n2max,n3max,n4max,ng,
     &            i1,i2max,i3max,i4max)
      end do

c write out array information

      call info(array,n1max,n2max,n3max,n4max,ng,flag,min,step)

c marginalise the probability function as required

5     do i=1,4
        flag(i)=0
      end do

      write(*,*)
      write(*,'(a,$)') ' Input the number of axes to marginalise: '
      read(*,*) ndim

      if (ndim.gt.0) then
        write(*,'(a,$)') ' Input which axes to marginalise: '
        read(*,*) (dims(i),i=1,ndim)
        do i=1,ndim
          flag(dims(i))=1
        end do
      end if

      do i1=1,ng(1)
      do i2=1,ng(2)
      do i3=1,ng(3)
      do i4=1,ng(4)
        if (ndim.gt.0) then
          margarr(i1,i2,i3,i4)=0d0
        else
          margarr(i1,i2,i3,i4)=array(i1,i2,i3,i4)
        end if
      end do
      end do
      end do
      end do

      if (ndim.eq.0) then
        do i=1,4
          mg(i)=ng(i)
        end do
        goto 50
      end if

      do i1=1,(ng(1)-1)*(1-flag(1))+1
      do i2=1,(ng(2)-1)*(1-flag(2))+1
      do i3=1,(ng(3)-1)*(1-flag(3))+1
      do i4=1,(ng(4)-1)*(1-flag(4))+1
        margarr(i1,i2,i3,i4)=0d0
        do j1=flag(1)+i1*(1-flag(1)),ng(1)*flag(1)+i1*(1-flag(1))
        do j2=flag(2)+i2*(1-flag(2)),ng(2)*flag(2)+i2*(1-flag(2))
        do j3=flag(3)+i3*(1-flag(3)),ng(3)*flag(3)+i3*(1-flag(3))
        do j4=flag(4)+i4*(1-flag(4)),ng(4)*flag(4)+i4*(1-flag(4))
          margarr(i1,i2,i3,i4)=margarr(i1,i2,i3,i4)+array(j1,j2,j3,j4)
        end do
        end do
        end do
        end do
      end do
      end do
      end do
      end do

c write out information about marginalised array

      do i=1,4
        mg(i)=(ng(i)-1)*(1-flag(i))+1
      end do
      write(*,*)
      write(*,'(a,4i3)') ' Array has dimensions ',
     &  mg(1),mg(2),mg(3),mg(4)
      write(*,*)
      do i=1,4
        if (flag(i).eq.0) then
          write(*,'(a,i2,a,2g10.4)') ' Limits on axis ',i,' are ',
     &      min(i),max(i) 
        end if
      end do

c normalise each bin to unity at peak

      write(*,*)
      write(*,*) ' Normalising array peak to unity in each bin...'
      do i1=1,mg(1)
        call norm2(margarr,n1max,n2max,n3max,n4max,mg,
     &             i1,i2max,i3max,i4max)
      end do

c write out array information

      call info(margarr,n1max,n2max,n3max,n4max,mg,flag,min,step)

c write out ML power in each bin and errors

 50   call writeps(n1max,n2max,n3max,n4max,npmax,array,xarr,yarr,
     &             centre,ng,min,step)

c ask for plotting preferences

      ndim=0
      do i=1,4
        if (mg(i).eq.1) then
          label(i)=0
        else
          label(i)=1
        end if
        ndim=ndim+label(i)
        index(i)=1
      end do
      
      if (ndim.eq.1) then
        write(*,*)
        write(*,*) ' Marginalised array has only 1 dimension -',
     &             ' about to plot it'
        write(*,*)
        plot=1
        do i=1,4
          if (label(i).eq.1) then
            axes(i)=1
            ivar(1)=i
          else
            axes(i)=0
          end if
        end do
      else
        write(*,*)
        write(*,'(a,$)') ' Do you want a 1-D or 2-D plot? '
        read(*,'(i1)') plot
        if (plot.eq.1) then
 10       write(*,'(a,$)') ' Which axis do you want to plot? '
          read(*,'(i1)') ivar(1) 
          if (label(ivar(1)).eq.0) then
            write(*,*)
            write(*,*) ' ERROR: that is not a valid axis'
            write(*,*)
            goto 10
          end if
          do i=1,4
            if (i.eq.ivar(1)) then
              axes(i)=1
            else
              axes(i)=0
            end if
          end do
        else if (plot.eq.2) then
 20       write(*,'(a,$)') ' Which axes do you want to plot? '
          read(*,*) (ivar(i),i=1,2)
          if (label(ivar(1)).eq.0 .or. label(ivar(2)).eq.0) then
            write(*,*)
            write(*,*) ' ERROR: those are not valid axes'
            write(*,*)
            goto 20
          end if
          do i=1,4
            if (i.eq.ivar(1) .or. i.eq.ivar(2)) then
              axes(i)=1
            else
              axes(i)=0
            end if
          end do
        end if
      end if


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c 1-D plotting
      if (plot.eq.1) then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c option to plot 2-D equivalent GACF distribution

      gacfyn='n'
      if (axes(3).eq.1 .or. axes(4).eq.1) then
        write(*,'(a,$)')' Plot equivalent GACF distribution (y/n)? [n] '
        read(*,'(a1)') gacfyn
      end if
      if (gacfyn.ne.'y' .and. gacfyn.ne.'Y') goto 699

      do j=2,4
        if (axes(j).eq.1) then
          xmin=min(j)
          xmax=max(j)
          xstep=step(j)
          xnpts=mg(j)
        end if
        if (label(j).eq.1 .and. axes(j).eq.0) then
          write(*,*)
          write(*,'(a,i1,a,f8.2,a,f8.2)') 
     &      ' Coordinate limits on axis ',j,' are ',min(j),
     &      ' to ',max(j) 
          write(*,'(a,$)') ' Input required coordinate on this axis: '
          read(*,*) coord
          index(j)=int((coord-min(j))/step(j)+0.5)+1
          write(*,'(a,i2,a,f8.2)') 
     &      ' The coordinate used on axis ',
     &      j,' is ',min(j)+(index(j)-1)*step(j)
        end if
      end do
      do i1=1,mg(1)
      i=0
      do i2=index(2),(mg(2)-1)*axes(2)+index(2)
      do i3=index(3),(mg(3)-1)*axes(3)+index(3)
      do i4=index(4),(mg(4)-1)*axes(4)+index(4)
        i=i+1
        xarr(i)=xmin+(i-1)*xstep
        wkspc3(i1,i)=real(margarr(i1,i2,i3,i4))
      end do
      end do
      end do
      end do
      npts=i
c ...initialise variables
      do i=1,npmax
        do j=1,npmax
          xyarr(i,j)=1.0
        end do
      end do
      if (ivar(1).eq.3) then
        gaxlab(1)='\\gh\\d\\fic\\u \\fr(arcmin)'
        gaxlab(2)='\\(2267)\\fiC\\d0\\u \\fr(\\gm\\frK)'
      else if (ivar(1).eq.4) then
        gaxlab(1)='\\gh\\d\\fig\\u \\fr(arcmin)'
        gaxlab(2)='\\(2267)\\fiG\\d0\\u \\fr(\\gm\\frK)'
      end if
c ...ask for information
c      x=freq0/56.8      
c      x=2.*(x**2)/(exp(x/2)-exp(-x/2))
c      k_to_jy=(24.8e6)*(x**2)
c      write(*,*)
c      write(*,*) '  K to Jy/sr conversion = ',k_to_jy
c      write(*,*)

      write(*,'(a,$)') ' Input limits on sqrt(C_0) (uK): '
      read(*,*) ymin,ymax
      write(*,'(a,$)') ' Input limits on theta_c (arcmin): '
      read(*,*) xmin,xmax
      write(*,'(a,$)') ' Input no. of points on each axis: '
      read(*,*) ynpts,xnpts
      xstep=(xmax-xmin)/float(xnpts-1)
      ystep=(ymax-ymin)/float(ynpts-1)
c ...calculate equivalent 2-D GACF distribution
      do i1=1,mg(1)
        yp1=1.0e30
        ypn=1.0e30
        do i2=1,npts
          yarr(i2)=wkspc3(i1,i2)   
        end do
        call spline(xarr,yarr,npts,yp1,ypn,wkspc1)
        do i=1,xnpts
          theta_c=(xmin+float(i-1)*xstep)*minrad
          do j=1,ynpts
            c0=((ymin+float(j-1)*ystep)*1.0e-6)**2
            xnew=gaussps(c0,theta_c,centre(i1))
            if (psax.eq.1) xnew=xnew*(centre(i1)**2)/(2.0*pi)
            call splint(xarr,yarr,wkspc1,npts,xnew,ynew)
            if (ynew.lt.0.0) ynew=0.0
            xyarr(i,j)=xyarr(i,j)*ynew
          end do
        end do
      end do
c ...convert to dT/T if required 
      write(*,'(a,$)') ' Convert uK to dT/T (y/n)? [n] '
      read(*,'(a1)') convert
      if (convert.eq.'y' .or. convert.eq.'Y') then
        ymin=ymin*1.0e-6/t0
        ymax=ymax*1.0e-6/t0
        ystep=ystep*1.0e-6/t0
        if (ivar(1).eq.3) then
          gaxlab(2)='\\(2267)\\fiC\\d0\\u'
        else if (ivar(1).eq.4) then
          gaxlab(2)='\\(2267)\\fiG\\d0\\u'
        end if
      end if
      do i=1,xnpts
        xarr(i)=xmin+float(i-1)*xstep
      end do
      do i=1,ynpts
        yarr(i)=ymin+float(i-1)*ystep
      end do

c ...interpolate 2-D function if required
      call int2d(xarr,yarr,xyarr,wkspc3,wkspc4,npmax,xnpts,ynpts,
     &           xmin,xmax,ymin,ymax,xstep,ystep)
c ... plot the array
      call startpg(xmin,xmax,ymin,ymax)
      call pgsci(3)
      trans(1)=xmin-0.5*xstep
      trans(2)=xstep
      trans(3)=0
      trans(4)=ymin-0.5*ystep
      trans(5)=0
      trans(6)=ystep
      call pglabel(gaxlab(1),gaxlab(2),title(1))
      call pgsci(6)
      write(*,'(a,$)') ' Plot greyscale (y/n)? [n] '
      read(*,'(a1)') grchoice
      if (grchoice.eq.'y' .or. grchoice.eq.'Y') then
        call pgqinf('HARDCOPY',hard,len)
        if (hard.eq.'YES') then
          call pggray(xyarr,npmax,npmax,1,xnpts,1,ynpts,
     &                0.0e0,1.0e0,trans)
        else
          call pggray(xyarr,npmax,npmax,1,xnpts,1,ynpts,
     &                1.0e0,0.0e0,trans)
        end if
      end if
      call pgsci(2)
      call pgbox('ABCTSN',0.0,0,'ABCTSN',0.0,0)
c ...add confidence contours to plot if required
      write(*,'(a,$)') ' Plot confidence contours (y/n)? [n] '
      read(*,'(a1)') choice
      if (choice.eq.'y' .or. choice.eq.'Y') then
        call plot_conts(xyarr,wkspc1,npmax,xnpts,ynpts,trans,
     &                  xarr,wkspc2,grchoice)
        write(*,*)
      end if
c ...write out GACF array if required
      write(*,'(a,$)') ' Write out the GACF array to a file (y/n)? [n] '
      read(*,'(a1)') choice
      if (choice.eq.'y' .or. choice.eq.'Y') then
        write(*,'(a,$)') ' Output filename for 2-D array? '
        read(*,'(a)') outfn
        open(14,file=outfn,form='formatted',access='sequential',
     &       status='unknown')
        do i=1,xnpts
          do j=1,ynpts
            write(14,*) xarr(i),yarr(j),xyarr(i,j)
          end do
        end do
        close(14)
      end if
c ...plot 1-D array from GACF distribution if required
      write(*,'(a,$)')
     &  ' Plot 1-D array from GACF distribution (y/n)? [n] '
      read(*,'(a1)') choice
      if (choice.ne.'y' .and. choice.ne.'Y') goto 500
      write(*,'(a,$)')
     &  ' Plot rms axis (1) or coherence angle axis (2): '
      read(*,*) gacfax
      if (gacfax.eq.1) then
        do i=1,ynpts
          xarr(i)=yarr(i)
        end do
        ymin=xmin
        ymax=xmax
        ystep=xstep
        xmin=xarr(1)
        xmax=xarr(ynpts)
      end if
      write(*,'(a,f8.2,a,f8.2)') 
     &      ' Coordinate limits on other axis are ',ymin,
     &      ' to ',ymax 
      write(*,'(a,$)') ' Input required coordinate on this axis: '
      read(*,*) coord
      indx=int((coord-ymin)/ystep+0.5)+1
      write(*,'(a,f8.2)') ' The coordinate used on this axis is ',
     &  ymin+(indx-1)*ystep
      if (gacfax.eq.1) then
        do i=1,ynpts
          yarr(i)=xyarr(indx,i)
        end do
        xnpts=ynpts
      else
        do i=1,xnpts
          yarr(i)=xyarr(i,indx)
        end do
      end if
c ...interpolate 1-D array if required
      call int1d(xarr,yarr,wkspc1,wkspc2,npmax,xnpts,xmin,xmax)
c ...plot the arrays
      ymin=0.0
      ymax=1.0
      call startpg(xmin,xmax,ymin,ymax)
      call pgsci(3)
      if (gacfax.eq.1) call pglabel(gaxlab(2),title(2),title(1))
      if (gacfax.eq.2) call pglabel(gaxlab(1),title(2),title(1))
      call pgsci(2)
      call pgbox('ABCTSN',0.0,0,'ABCTSN',0.0,0)
      call pgsci(6)
      call pgline(xnpts,xarr,yarr)
c ...calculate confidence intervals if required
      write(*,'(a,$)') ' Calculate confidence intervals (y/n)? [n] '
      read(*,'(a1)') choice
      if (choice.eq.'y' .or. choice.eq.'Y') then
        call calc_ints(xarr,yarr,xnpts)
      end if
c ...write out 1-D array if required
      write(*,'(a,$)') ' Write out the 1-D array to a file (y/n)? [n] '
      read(*,'(a1)') choice
      if (choice.eq.'y' .or. choice.eq.'Y') then
        write(*,'(a,$)') ' Output filename for 1-D array? '
        read(*,'(a)') outfn
        open(14,file=outfn,form='formatted',access='sequential',
     &       status='unknown')
        do i=1,xnpts
          write(14,*) xarr(i),yarr(i)
        end do
        close(14)
      end if

      goto 500

c  1-D plot against power spectrum 

 699  do j=1,4
        if (axes(j).eq.1) then
          xmin=min(j)
          xmax=max(j)
          xstep=step(j)
          xnpts=mg(j)
        end if
        if (label(j).eq.1 .and. axes(j).eq.0) then
          write(*,*)
          write(*,'(a,i1,a,f8.2,a,f8.2)') 
     &      ' Coordinate limits on axis ',j,' are ',min(j),
     &      ' to ',max(j) 
          write(*,'(a,$)') ' Input required coordinate on this axis: '
          read(*,*) coord
          index(j)=int((coord-min(j))/step(j)+0.5)+1
          if (j.eq.1) then
            write(*,'(a,i2,a,f8.2)') ' The coordinate used on axis ',
     &        j,' is ',p1pts(index(j))
          else
             write(*,'(a,i2,a,f8.2)') ' The coordinate used on axis ',
     &        j,' is ',min(j)+(index(j)-1)*step(j)
          end if
        end if
      end do
      ymin=0.0
      ymax=1.0
      i=0
      do i1=index(1),(mg(1)-1)*axes(1)+index(1)
      do i2=index(2),(mg(2)-1)*axes(2)+index(2)
      do i3=index(3),(mg(3)-1)*axes(3)+index(3)
      do i4=index(4),(mg(4)-1)*axes(4)+index(4)
        i=i+1
        xarr(i)=xmin+(i-1)*xstep
        yarr(i)=real(margarr(i1,i2,i3,i4))
      end do
      end do
      end do
      end do
c ...interpolate 1-D array if required
      call int1d(xarr,yarr,wkspc1,wkspc2,npmax,xnpts,xmin,xmax)
c ...plot the arrays
      call startpg(xmin,xmax,ymin,ymax)
      call pgsci(3)
      do i=1,4
        if (axes(i).eq.1) call pglabel(axlab(i),title(2),title(1))
      end do
      call pgsci(2)
      call pgbox('ABCTSN',0.0,0,'ABCTSN',0.0,0)
      call pgsci(6)
      call pgline(xnpts,xarr,yarr)
c ...calculate confidence intervals if required
      write(*,'(a,$)') ' Calculate confidence intervals (y/n)? [n] '
      read(*,'(a1)') choice
      if (choice.eq.'y' .or. choice.eq.'Y') then
        call calc_ints(xarr,yarr,xnpts)
      end if
c ...write out 1-D array if required
      write(*,'(a,$)') ' Write out the 1-D array to a file (y/n)? [n] '
      read(*,'(a1)') choice
      if (choice.eq.'y' .or. choice.eq.'Y') then
        write(*,'(a,$)') ' Output filename for 1-D array? '
        read(*,'(a)') outfn
        open(14,file=outfn,form='formatted',access='sequential',
     &       status='unknown')
        do i=1,xnpts
          write(14,*) xarr(i),yarr(i)
        end do
        close(14)
      end if

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c end 1-D plotting
      end if
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c 2-D plotting
      if (plot.eq.2) then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c ...calculate plotting arrays
        j=0
70      j=j+1
        if (axes(j).eq.0) goto 70
        xmin=min(j)
        xmax=max(j)
        xstep=step(j)
        xnpts=mg(j)
        xaxis=j
60      j=j+1
        if (axes(j).eq.0) goto 60
        ymin=min(j)
        ymax=max(j)
        ystep=step(j)
        ynpts=mg(j)
        yaxis=j
        do j=1,4
          if (label(j).eq.1 .and. axes(j).eq.0) then
            write(*,*)
            write(*,'(a,i1,a,f8.2,a,f8.2)') 
     &        ' Coordinate limits on axis ',j,' are ',min(j),
     &        ' to ',max(j) 
            write(*,'(a,$)') ' Input required coordinate on this axis: '
            read(*,*) coord
            index(j)=int((coord-min(j))/step(j)+0.5)+1
            if (j.eq.1) then
              write(*,'(a,i2,a,f8.2)') ' The coordinate used on axis ',
     &          j,' is ',p1pts(index(j))
            else
              write(*,'(a,i2,a,f8.2)') ' The coordinate used on axis ',
     &          j,' is ',min(j)+(index(j)-1)*step(j)
            end if
          end if
        end do
        k=0
        do i1=index(1),(mg(1)-1)*axes(1)+index(1)
        do i2=index(2),(mg(2)-1)*axes(2)+index(2)
        do i3=index(3),(mg(3)-1)*axes(3)+index(3)
        do i4=index(4),(mg(4)-1)*axes(4)+index(4)
          k=k+1
          j=k-(k/ynpts)*ynpts
          if (j.eq.0) j=ynpts
          i=((k-1)/ynpts)+1
          xyarr(i,j)=margarr(i1,i2,i3,i4)
        end do
        end do
        end do
        end do
c ...interpolate 2-D function if required
        call int2d(xarr,yarr,xyarr,wkspc3,wkspc4,npmax,xnpts,ynpts,
     &             xmin,xmax,ymin,ymax,xstep,ystep)
c ...plot the arrays
        call startpg(xmin,xmax,ymin,ymax)
        call pgsci(3)
        i=0
80      i=i+1
        if (axes(i).eq.0) goto 80 
        ivar(1)=i
90      i=i+1
        if (axes(i).eq.0) goto 90 
        ivar(2)=i
        trans(1)=xmin-0.5*xstep
        trans(2)=xstep
        trans(3)=0
        trans(4)=ymin-0.5*ystep
        trans(5)=0
        trans(6)=ystep
        call pglabel(axlab(xaxis),axlab(yaxis),title(1))
        call pgsci(6)
        write(*,'(a,$)') ' Plot greyscale (y/n)? [n] '
        read(*,'(a1)') grchoice
        if (grchoice.eq.'y' .or. grchoice.eq.'Y') then
          call pgqinf('HARDCOPY',hard,len)
          if (hard.eq.'YES') then
            call pggray(xyarr,npmax,npmax,1,xnpts,1,ynpts,
     &                  0.0e0,1.0e0,trans)
          else
            call pggray(xyarr,npmax,npmax,1,xnpts,1,ynpts,
     &                  1.0e0,0.0e0,trans)
          end if
        end if
        call pgsci(2)
        call pgbox('ABCTSN',0.0,0,'ABCTSN',0.0,0)
c ...add confidence contours to plot if required
        write(*,'(a,$)') ' Plot confidence contours (y/n)? [n] '
        read(*,'(a1)') choice
        if (choice.eq.'y' .or. choice.eq.'Y') then
          call plot_conts(xyarr,wkspc1,npmax,xnpts,ynpts,trans,
     &                    xarr,wkspc2,grchoice)
          write(*,*)
        end if
c ...write out 2-D array if required
        write(*,'(a,$)')' Write out the 2-D array to a file (y/n)? [n] '
        read(*,'(a1)') choice
        if (choice.eq.'y' .or. choice.eq.'Y') then
          write(*,'(a,$)') ' Output filename for 2-D array? '
          read(*,'(a)') outfn
          open(14,file=outfn,form='formatted',access='sequential',
     &         status='unknown')
          do i=1,xnpts
            do j=1,ynpts
              write(14,*) xarr(i),yarr(j),xyarr(i,j)
            end do
          end do
          close(14)
        end if

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c end 2-D plotting
      end if
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c give options for other marginalisation and/or plotting

 500  write(*,*)
      write(*,'(a,$)') ' Plot different axes (y/n)? [n] '
      read(*,'(a1)') choice
      if (choice.eq.'y' .or. choice.eq.'Y') goto 50

      write(*,'(a,$)') ' Marginalise different axes (y/n)? [n] '
      read(*,'(a1)') choice
      if (choice.eq.'y' .or. choice.eq.'Y') goto 5

      write(*,'(a,$)') ' Open new plot device (y/n)? [n] '
      read(*,'(a1)') choice
      if (choice.eq.'y' .or. choice.eq.'Y') then
        call pgend
        call pgbegin(0,'?',1,1)
        goto 5
      end if

c close PGPLOT window and stop

      call pgend
      end

c-----*-----------------------------------------------------------------

      subroutine norm2(array,n1max,n2max,n3max,n4max,ng,
     &                 i1,i2max,i3max,i4max)
      implicit none
      integer*4 n1max,n2max,n3max,n4max
      real*8    array(n1max,n2max,n3max,n4max)
      integer*4 ng(4)
      integer*4 i1,i2,i3,i4
      integer*4 i2max,i3max,i4max
      real*8    arrmax

      arrmax=-1d20
      do i2=1,ng(2)
        do i3=1,ng(3)
          do i4=1,ng(4)
            if (array(i1,i2,i3,i4).gt.arrmax) then
              arrmax=array(i1,i2,i3,i4)
              i2max=i2
              i3max=i3
              i4max=i4
            end if
          end do
        end do
      end do
      do i2=1,ng(2)
        do i3=1,ng(3)
          do i4=1,ng(4)
            array(i1,i2,i3,i4)=array(i1,i2,i3,i4)/arrmax
          end do
        end do
      end do

      return

      end

c-----*-----------------------------------------------------------------

      subroutine info(array,n1max,n2max,n3max,n4max,ng,flag,min,step)
      implicit none
      integer*4 n1max,n2max,n3max,n4max
      real*8    array(n1max,n2max,n3max,n4max)
      integer*4 ng(4),flag(4)
      real*4    min(4),step(4)
      integer*4 i1,i2,i3,i4
      integer*4 i2max,i3max,i4max
      integer*4 galyn
      real*8    arrmax,tiny

      tiny=1d-20
      galyn=1
      if ((ng(4).eq.1).and.(min(4).lt.tiny)) galyn=0 

      write(*,*)
      write(*,*) ' Maximum in array occurs at:'

      if (.not.(flag(3).eq.1 .and. flag(4).eq.1)) then
      do i2=1,ng(2)
        if ((galyn.eq.1).and.(flag(2).eq.0)) then
          write(*,*)
          write(*,*) ' For alpha = ',min(2)+(i2-1)*step(2) 
        end if
        do i1=1,ng(1)
          arrmax=-1d20
          do i3=1,ng(3)
            do i4=1,ng(4)
              if (array(i1,i2,i3,i4).gt.arrmax) then
                arrmax=array(i1,i2,i3,i4)
                i3max=i3
                i4max=i4
              end if
            end do
          end do
          write(*,*)
          write(*,'(a,i3,a)') '  In annulus ',i1,':'
          if (flag(3).eq.0)     
     &      write(*,*) '   CMB power spectrum = ',
     &      min(3)+(i3max-1)*step(3)
          if ((galyn.eq.1).and.(flag(4).eq.0)) 
     &      write(*,*) '   GAL power spectrum = ',
     &      min(4)+(i4max-1)*step(4)
        end do
      end do
      else
        do i1=1,ng(1)
          arrmax=-1d20
          do i2=1,ng(2)
            if (array(i1,i2,1,1).gt.arrmax) then
              arrmax=array(i1,i2,1,1)
              i2max=i2
            end if
          end do
          write(*,*)
          write(*,'(a,i3,a)') '  In annulus ',i1,':'
          write(*,*) '   GAL spectral index = ',
     &      min(2)+(i2max-1)*step(2)
        end do
      end if

      return
      end       

c-----*-----------------------------------------------------------------

      subroutine writeps(n1max,n2max,n3max,n4max,npmax,array,xarr,yarr,
     &                   centre,ng,min,step)
      implicit none
      integer*4 n1max,n2max,n3max,n4max,npmax
      real*8    array(n1max,n2max,n3max,n4max)
      real*4    xarr(npmax),yarr(npmax),centre(n1max)
      integer*4 ng(4)
      real*4    min(4),step(4)
      real*4    maxpos,minus,plus,tiny,coord,level,limit
      integer*4 i1,i2,i3,i4
      integer*4 galyn,xnpts
      logical   cmbfix,galfix
      character psfile*60,choice*1

      tiny=1e-20
      limit=0.68
      galyn=1
      if ((ng(4).eq.1).and.(min(4).lt.tiny)) galyn=0 

c ask for PS 

      write(*,'(a,$)') ' Write out ML power in each bin (y/n)? [n]: '
      read(*,'(a1)') choice
      if (.not.(choice.eq.'y' .or. choice.eq.'Y')) goto 999

c input values of alpha, cps and gps

      if (galyn.eq.1) then
        write(*,'(a,$)') ' Input alpha for power spectrum: '
        read(*,*) coord
          i2=int((coord-min(2))/step(2)+0.5)+1
          write(*,'(a,i2,a,f8.2)') 
     &      ' Using alpha = ',min(2)+(i2-1)*step(2)
      else
        i2=1
      end if

      write(*,'(a,$)') ' Input CMB power in bin (-1 for free): '
      read(*,*) coord
      if (coord.ne.-1) then
        i3=int((coord-min(3))/step(3)+0.5)+1
        write(*,'(a,i2,a,f8.2)') 
     &      ' Using CMB power = ',min(3)+(i3-1)*step(3)
        cmbfix=.true.
        galfix=.false.
      end if

      write(*,'(a,$)') ' Input Galaxy power in bin (-1 for free): '
      read(*,*) coord
      if (coord.ne.-1) then
        i4=int((coord-min(4))/step(4)+0.5)+1
        write(*,'(a,i2,a,f8.2)') 
     &      ' Using Galaxy power = ',min(4)+(i4-1)*step(4)
        cmbfix=.false.
        galfix=.true.
      end if

c open output file

      write(*,'(a,$)') ' Enter filename for power spectrum: '
      read(*,'(a)') psfile
      open(unit=21,form='formatted',file=psfile,status='unknown')

c loop over bins and write estimate and error to file

      do i1=1,ng(1)
c ... write likelihood function to 1-D array
        if (cmbfix) then
          do i4=1,ng(4)
            xarr(i4)=min(4)+(i4-1)*step(4)
            yarr(i4)=real(array(i1,i2,i3,i4))
          end do
          xnpts=ng(4)
        else if (galfix) then
          do i3=1,ng(3)
            xarr(i3)=min(3)+(i3-1)*step(3)
            yarr(i3)=real(array(i1,i2,i3,i4))
c            write(*,*) xarr(i3),yarr(i3)
          end do
          xnpts=ng(3)
        end if
c ...calculate confidence intervals if required
        call conf1d(xarr,yarr,xnpts,maxpos,plus,minus,limit,level)
        write(21,*) i1,centre(i1),maxpos,minus,plus
      end do

c close output file, return and end

      close(21)

 999  return
      end

c-----*-----------------------------------------------------------------

c subroutine to carry out 1-D cubic spline interpolation of data

      subroutine int1da(xarr,yarr,wkspc1,wkspc2,npmax,npts,
     &                  xmin,xmax,nint,xstep)
      implicit none
      integer*4 npmax,npts,nint
      real*4    xarr(npmax),yarr(npmax)
      real*4    wkspc1(npmax),wkspc2(npmax)
      integer*4 i
      real*4    yp1,ypn,xmin,xmax,xstep,xnew,ynew

      xstep=(xmax-xmin)/float(nint-1)
      yp1=1e30
      ypn=1e30
      call spline(xarr,yarr,npts,yp1,ypn,wkspc1)
      do i=1,nint
        xnew=xmin+(i-1)*xstep
        call splint(xarr,yarr,wkspc1,npts,xnew,ynew)
        if (ynew.lt.0.0) ynew=0.
        wkspc2(i)=ynew
      end do
      do i=1,nint
        xarr(i)=xmin+(i-1)*xstep
        yarr(i)=wkspc2(i)
      end do

      end

c-----*-----------------------------------------------------------------

c subroutine to carry out 2-D bicubic spline interpolation of data

      subroutine int2da(xarr,yarr,xyarr,wkspc3,wkspc4,npmax,xnpts,
     &                  ynpts,xmin,xmax,ymin,ymax,nint,xstep,ystep)
      implicit none
      integer*4 npmax,xnpts,ynpts,nint(2)
      real*4    xarr(npmax),yarr(npmax),xyarr(npmax,npmax)
      real*4    wkspc3(npmax,npmax),wkspc4(npmax,npmax)
      integer*4 xnint,ynint,i,j
      real*4    xmin,xmax,xstep,xnew
      real*4    ymin,ymax,ystep,ynew,xynew

      xnint=nint(1)
      ynint=nint(2)
      xstep=(xmax-xmin)/float(xnint-1)
      ystep=(ymax-ymin)/float(ynint-1)
      call splie2(xarr,yarr,xyarr,xnpts,ynpts,npmax,npmax,wkspc3)
      do i=1,xnint
        do j=1,ynint
          xnew=xmin+(i-1)*xstep
          ynew=ymin+(j-1)*ystep
          call splin2(xarr,yarr,xyarr,wkspc3,xnpts,ynpts,
     &                npmax,npmax,xnew,ynew,xynew)
          wkspc4(i,j)=xynew
        end do
      end do
      do i=1,xnint
        xarr(i)=xmin+(i-1)*xstep
        yarr(i)=ymin+(i-1)*ystep
        do j=1,ynint
          xyarr(i,j)=wkspc4(i,j)
        end do
      end do

      end

c-----*-----------------------------------------------------------------

c function to return the power in dT/T at a point l (multipoles)
c for a given c0 (in K**2) and theta_c (in rads)

      real*4 function gaussps(c0,theta_c,l)
      implicit none
      real*4   c0,theta_c,l
      real*4   pi,arg,t0

      pi=3.14159
      t0=2.726

      arg=(theta_c**2)*(l**2)/2.0
      gaussps=2.*pi*c0*(theta_c**2)*exp(-arg)
      gaussps=gaussps/(t0**2)

      return

      end

c-----*-----------------------------------------------------------------

      include "plotsubs.f"
      include "splines.f"

c-----*-----------------------------------------------------------------

