c-----*-----------------------------------------------------------------

* subroutine to calculate 1-D confidence limits

      subroutine calc_ints(xarr,yarr,npts)
      implicit none
      integer*4 npts
      real*4    xarr(npts),yarr(npts)
      real*4    max,plus,minus,limit,level

168   write(*,169)
169   format(' Input required confidence limit (-1 to end): ',$)
      read(*,*) limit
      if (limit.lt.0.0) goto 999
      if (limit.ge.1.0) then
        write(*,*)
        write(*,*) ' ERROR: Confidence limit must lie between 0 and 1'
        write(*,*)
        goto 168
      end if
      call conf1d(xarr,yarr,npts,max,plus,minus,limit,level)
      write(*,*) 
      write(*,*) 'Position of maximum = ',max 
      write(*,'(a,f5.1,a,g10.4)') ' Lower ',limit*100.,
     &       '% confidence limit = ',minus 
      write(*,'(a,f5.1,a,g10.4)') ' Upper ',limit*100.,
     &       '% confidence limit = ',plus 
      write(*,*)
      goto 168

999   end

c-----*-----------------------------------------------------------------

c subroutine to plot the confidence contours

      subroutine plot_conts(array,wkspc1,maxsiz,xsize,ysize,trans,
     &                      xarr,levels,grchoice)
      implicit none
      integer*4 nconts
      parameter (nconts=11)
      integer*4 maxsiz,xsize,ysize,ncount,i,j
      real*4    conts(nconts),array(maxsiz,maxsiz),trans(6)
      real*4    xarr(maxsiz),wkspc1(maxsiz)
      real*4    limit,level,max,plus,minus
      real*4    levels(maxsiz)
      real*4    median
      character choice*1,grchoice*1

      external  median

      write(*,171)
171   format(' Does the likelihood tend to zero at edges',
     &        ' of region (y/n)? [n] ',$)
      read(*,'(a1)') choice
 
c if likelihood tends to zero at edges then calculate contours

      if (choice.eq.'y' .or. choice.eq.'Y') then
        write(*,*)
        write(*,*) ' confidence contours are as follows: ' 
        write(*,*)
        do i=1,nconts-1 
          limit=float(i-1)*0.1
          call conf2d(array,maxsiz,xsize,ysize,limit,level)
          conts(i)=level
          if (i.gt.1) then
            if (conts(i).ge.conts(i-1)) conts(i)=conts(i-1)-0.01
          end if
        end do
        limit=0.95
        call conf2d(array,maxsiz,xsize,ysize,limit,level)
        conts(nconts)=level
        if (conts(nconts).ge.conts(nconts-1)) 
     &    conts(nconts)=conts(nconts-1)-0.01
        if (grchoice.eq.'y' .or. grchoice.eq.'Y') then
          do i=1,nconts
            if (conts(i).ge.0.5) then
              call pgsci(0)
            else
              call pgsci(1)
            end if
            call pgcont(array,maxsiz,maxsiz,1,xsize,1,ysize,
     &                  conts(i),nconts,trans)
          end do
        else
          call pgsci(6)
          call pgcont(array,maxsiz,maxsiz,1,xsize,1,ysize,
     &                conts,nconts,trans)
        end if
      end if

c if likelihood does not tend to zero at edges then calculate contours

      if (choice.ne.'y' .and. choice.ne.'Y') then
        write(*,*)
        limit=0.
        ncount=0
        do while (limit.lt.0.9)
          ncount=ncount+1
          limit=limit+0.1
          do j=1,ysize
            do i=1,xsize
              wkspc1(i)=array(i,j)
            end do
            call conf1d(xarr,wkspc1,xsize,max,plus,minus,limit,level)
            levels(j)=level
          end do
          conts(ncount)=median(levels,ysize)
          write(*,'(1x,i3,a,f4.2)') int(limit*100.),
     &    '% confidence contour = ',conts(ncount)
          if (conts(nconts).ge.conts(nconts-1)) 
     &      conts(nconts)=conts(nconts-1)-0.01
        end do
        ncount=ncount+1
        limit=0.95
        do j=1,ysize
          do i=1,xsize
            wkspc1(i)=array(i,j)
          end do
          call conf1d(xarr,wkspc1,xsize,max,plus,minus,limit,level)
          levels(i)=level
        end do
        conts(ncount)=median(levels,ysize)
        write(*,'(1x,i3,a,f4.2)') int(limit*100.),
     &  '% confidence contour = ',conts(ncount)
        if (conts(ncount).ge.conts(ncount-1)) 
     &    conts(ncount)=conts(ncount-1)-0.01
        if (grchoice.eq.'y' .or. grchoice.eq.'Y') then
          do i=1,nconts
            if (conts(i).ge.0.5) then
              call pgsci(0)
            else
              call pgsci(1)
            end if
            call pgcont(array,maxsiz,maxsiz,1,xsize,1,ysize,
     &                  conts(i),nconts,trans)
          end do
        else
          call pgsci(6)
          call pgcont(array,maxsiz,maxsiz,1,xsize,1,ysize,
     &                conts,nconts,trans)
        end if
      end if

      end

c-----*-----------------------------------------------------------------

c subroutine to find the median of an array of numbers

      real function median(array,npts)
      implicit none
      integer*4 npts
      real*4    array(npts)

      call sort(array,npts)
      if (int(float(npts)/2.+0.5).eq.npts/2) then
        median=0.5*(array(npts/2)+array(npts/2+1))
      else
        median=array(npts/2)
      end if

      end

c-----*-----------------------------------------------------------------

c subroutine to sort an array of numbers

      subroutine sort(array,n)
      implicit none
      integer*4 n
      real*4    array(n)
      integer*4 i,k
      real*4    temp

      do k=2,n
        i=k
        do while (i.gt.1) 
          if (array(i-1).gt.array(i)) then
            temp=array(i-1)
            array(i-1)=array(i)
            array(i)=temp
            i=i-1
          else
            i=1
          end if
        end do
      end do

      end

c-----*-----------------------------------------------------------------

c subroutine to start up pgplot

      subroutine startpg(xmin,xmax,ymin,ymax)
      implicit none
      real*4   xmin,xmax,ymin,ymax

c      call pgbegin(0,'?',1,1)
      call pgsci(1)
      call pgslw(3)
      call pgscf(2)
      call pgsch(1.25)
      call pgenv(xmin,xmax,ymin,ymax,0,-2)
c      call pgvsize(1.0,6.6,1.0,5.0)

      end

c-----*-----------------------------------------------------------------

c Subroutine to return the confidence interval of a likelihood
c array y(ndata) with max likelihood 1. Step is the x increment, values
c returned in plus, minus

      subroutine conf1d(xr,yr,ndata,rmax,rplus,rminus,rlim,rlevel)

      implicit none
      integer*4 ndata,i,ifail,imax,maxpts
      parameter (maxpts=201)
      real*4    xr(ndata),yr(ndata),rmax,rplus,rminus,rlim,rlevel
      real*8    x(maxpts),y(maxpts),temp(maxpts),plus,minus,lim
      real*8    conf,level,norm,err,ymax,max,inc

      rlevel=0.
      inc=1d-2

      do i=1,ndata
        x(i)=dble(xr(i))
        y(i)=dble(yr(i))
      end do
      lim=dble(rlim)

      imax=1
      ymax=y(1)
      do i = 1, ndata
        if (y(i).gt.ymax) then
          ymax=y(i)
          imax=i
        end if
      end do
      max=x(imax)

      ifail=0
      call d01gaf(x,y,ndata,norm,err,ifail)

      level = 1
      conf = 0
      do while (conf.le.lim)
        level = level - inc
        do i = 1, ndata
          temp(i)=y(i)
          if (y(i).lt.level) temp(i)=0d0
        end do
        ifail=0
        call d01gaf(x,temp,ndata,conf,err,ifail)
        conf = conf/norm
      end do

      i=imax
      minus = 0d0
      do while (minus.eq.0d0 .and. i.gt.1)
        i = i - 1
        if (y(i).le.level) minus = x(i)
      end do
      if (i.gt.1) then
        minus=minus+(level-y(i))*(x(i+1)-x(i))/(y(i+1)-y(i))
      end if

      i=imax
      plus = 0d0
      do while (plus.eq.0d0 .and. i.lt.ndata)
        i = i + 1
        if (y(i).le.level) plus = x(i-1)
      end do
      if (i.eq.ndata) then
        plus=x(ndata)
      else
        plus=plus+(level-y(i-1))*(x(i)-x(i-1))/(y(i)-y(i-1))
      end if

      rlevel=real(level)
      rmax=real(max)
      rplus=real(plus)
      rminus=real(minus)

      end
           
c-----*-----------------------------------------------------------------

c subroutine to find confidence contours for 2D likelihood function

      subroutine conf2d(array,maxsiz,xsize,ysize,limit,level)
      implicit none
      integer*4 maxsiz,xsize,ysize,i,j,npts
      real*4    array(maxsiz,maxsiz)
      real*4    limit,level,norm,conf

      norm=0.
      do i=1,xsize
        do j=1,ysize
          norm=norm+array(i,j)
        end do
      end do

      level=1.
      conf=0.
      npts=0
      do while (conf.lt.limit)
        level=level-0.01
        conf=0.
        npts=0
        do i=1,xsize
          do j=1,ysize
            if (array(i,j).gt.level) then
              conf=conf+array(i,j)
              npts=npts+1
            end if
          end do
        end do
        conf=conf/norm
      end do
      write(*,'(1x,i3,a,f4.2,i5)') int(limit*100.),
     &  '% confidence contour, no. of pts in contour = ',level,npts

      end

c-----*-----------------------------------------------------------------

c subroutine to normalise array to 1 at peak

      subroutine norm(array,maxsiz,size,flag,max,min)
      implicit none
      integer*4 i1,i2,i3,i4,i5,maxsiz,size(5),flag(5)
      real*8    array(maxsiz,maxsiz,maxsiz,maxsiz,maxsiz)
      real*8    max,min

      do i1=1,(size(1)-1)*(1-flag(1))+1
      do i2=1,(size(2)-1)*(1-flag(2))+1
      do i3=1,(size(3)-1)*(1-flag(3))+1
      do i4=1,(size(4)-1)*(1-flag(4))+1
      do i5=1,(size(5)-1)*(1-flag(5))+1
        array(i1,i2,i3,i4,i5)=array(i1,i2,i3,i4,i5)/max
      end do
      end do
      end do
      end do
      end do

      min=min/max
      max=1d0

      end

c-----*-----------------------------------------------------------------

c subroutine to carry out 1-D cubic spline interpolation of data

      subroutine int1d(xarr,yarr,wkspc1,wkspc2,npmax,npts,xmin,xmax)
      implicit none
      integer*4 npmax,npts
      real*4    xarr(npmax),yarr(npmax)
      real*4    wkspc1(npmax),wkspc2(npmax)
      integer*4 nint,i
      real*4    yp1,ypn,xmin,xmax,xstep,xnew,ynew,ymax
      character choice*1

      write(*,*)
      write(*,222) 
222   format(1x,'Interpolate onto a finer grid (y/n)? [n] ',$)
      read(*,'(a1)') choice
      if (choice.eq.'y' .or. choice.eq.'Y') then
        write(*,223)
223     format(1x,'Input no. of interpolated grid points ',
     &              '(201 max.): ',$)
        read(*,'(i3)') nint
        xstep=(xmax-xmin)/float(nint-1)
        yp1=1e30
        ypn=1e30
        call spline(xarr,yarr,npts,yp1,ypn,wkspc1)
        ymax=0.0
        do i=1,nint
          xnew=xmin+(i-1)*xstep
          call splint(xarr,yarr,wkspc1,npts,xnew,ynew)
          if (ynew.lt.0.0) ynew=0.
          wkspc2(i)=ynew
          if (wkspc2(i).gt.ymax) ymax=wkspc2(i)
        end do
        do i=1,nint
          xarr(i)=xmin+(i-1)*xstep
          yarr(i)=wkspc2(i)/ymax
        end do
        npts=nint
      else
        ymax=0.0
        do i=1,npts
          if (yarr(i).gt.ymax) ymax=yarr(i)
        end do
      end if

      write(*,*)
      write(*,'(a,f7.2)') ' 1-D array maximum = ',ymax
      write(*,*)
      write(*,*) 'Renormalising to unity at the peak ...'
      write(*,*)
      if (yarr(1).gt.0.0)
     & write(*,'(a,a,g10.4)') ' Relative probability of maximum',
     &                      ' to origin = ',1.0/yarr(1)
      write(*,*)
      do i=1,npts
        yarr(i)=yarr(i)/ymax
      end do

      end

c-----*-----------------------------------------------------------------

c subroutine to carry out 2-D bicubic spline interpolation of data

      subroutine int2d(xarr,yarr,xyarr,wkspc3,wkspc4,npmax,
     &                 xnpts,ynpts,xmin,xmax,ymin,ymax,xstep,ystep)
      implicit none
      integer*4 npmax,xnpts,ynpts
      real*4    xarr(npmax),yarr(npmax),xyarr(npmax,npmax)
      real*4    wkspc3(npmax,npmax),wkspc4(npmax,npmax)
      integer*4 xnint,ynint,i,j
      real*4    xmin,xmax,xstep,xnew
      real*4    ymin,ymax,ystep,ynew,xynew,xymax
      character choice*1

      do i=1,xnpts
        xarr(i)=xmin+(i-1)*xstep
      end do
      do i=1,ynpts
        yarr(i)=ymin+(i-1)*ystep
      end do

      write(*,*)
      write(*,222) 
222   format(1x,'Interpolate onto a finer grid (y/n)? [n] ',$)
      read(*,'(a1)') choice
      if (choice.eq.'y' .or. choice.eq.'Y') then
        write(*,223)
223     format(1x,'Input no. of interpolated grid points ',
     &              'in each dimension (201 max.): ',$)
        read(*,*) xnint,ynint
        xstep=(xmax-xmin)/float(xnint-1)
        ystep=(ymax-ymin)/float(ynint-1)
        call splie2(xarr,yarr,xyarr,xnpts,ynpts,npmax,npmax,wkspc3)
        xymax=0.0
        do i=1,xnint
          do j=1,ynint
            xnew=xmin+(i-1)*xstep
            ynew=ymin+(j-1)*ystep
            call splin2(xarr,yarr,xyarr,wkspc3,xnpts,ynpts,
     &                  npmax,npmax,xnew,ynew,xynew)
            if (xynew.lt.0.0) xynew=0.
            wkspc4(i,j)=xynew
            if (wkspc4(i,j).gt.xymax) xymax=wkspc4(i,j)
          end do
        end do
        do i=1,xnint
          xarr(i)=xmin+(i-1)*xstep
          yarr(i)=ymin+(i-1)*ystep
          do j=1,ynint
            xyarr(i,j)=wkspc4(i,j)/xymax
          end do
        end do
        xnpts=xnint
        ynpts=ynint
      else
        xymax=0.0
        do i=1,xnpts
          do j=1,ynpts
            if (xyarr(i,j).gt.xymax) xymax=xyarr(i,j)
          end do
        end do
      end if

      write(*,*)
      write(*,'(a,f7.2)') ' 2-D array maximum = ',xymax
      write(*,*)
      write(*,*) 'Renormalising to unity at the peak ...'
      write(*,*)
      if (xyarr(1,1).gt.0.)
     & write(*,'(a,a,g10.4)') ' Relative probability of maximum',
     &                      ' to axes = ',1.0/xyarr(1,1)
      write(*,*)
      do i=1,xnpts
        do j=1,ynpts
          xyarr(i,j)=xyarr(i,j)/xymax
        end do
      end do
      

      end

c-----*-----------------------------------------------------------------



