/*  Time-stamp: <28 Jan 2002 13:04 GMT like_covariance.h maising> */

#ifndef __LIKE_COVARIANCE_H
#define __LIKE_COVARIANCE_H

#include "integration.h"
#include "like_integrals.h"

typedef struct {
  int nv;			/* number of visibilities */
  int nz;             /* number of non-zero matrix elements */
  int *irn, *icn;     /* index for non-zero elements of covariance matrix */
  double *cm;  /* real and imag parts of covariance matrix*/
  int *pxx, *pyy, *pxy, *pyx;	/* index lookup table for efficient 
				   creation of cm sets */
  int imaginary_flag;
} cm_struct;



double cmbfcn(double tcmb, double freq);
double dt_to_di(double t_cmb, double freq);
int countcms(integral_struct *ints);
void newcms(cm_struct *cms, int nv, int nz);
void freecms(cm_struct *cms);
void copycms(cm_struct *cm1, cm_struct *cm2);
void makeidxcms(cm_struct *cms, integral_struct *ints);
void freeidxcms(cm_struct *cms);
void makesm(double *cps1d, double *gps1d, int na, 
	    double sp, double *freq, int nf, double freq0, double convf, 
	    integral_struct *ints, cm_struct *cms, int rank, int npe);
void makenm(double *rms, int nv, integral_struct *ints,
	    cm_struct *cms, int rank, int npe);
void makecm(double *rms, int nv, double *cps1d, double *gps1d, int na, 
	    double sp, double *freq, int nf, double freq0, double convf, 
	    integral_struct *ints, cm_struct *cms, int rank, int npe);
void makesmnm(double *rms, int nv, double *cps1d, double *gps1d, int na, 
	      double sp, double *freq, int nf, double freq0, double convf, 
	      int ita, integral_struct *int_data,
	      cm_struct *sm_data, cm_struct *nm_data, int rank, int npe);
void makedcm(double *rms, int nv, double *cps1d, double *gps1d, int na, 
	     double sp, double *freq, int nf, double freq0, double convf, 
	     int idx, integral_struct *ints, cm_struct *cms, 
	     int rank, int npe);
void makedsm(double *cps1d, double *gps1d, int na, 
	     double sp, double *freq, int nf, double freq0, double convf, 
	     int idx, integral_struct *ints, cm_struct *cms,
	     int rank, int npe);
#endif
