/*  Time-stamp: <30 Oct 2002 13:38 GMT like_io.h maising> */
#ifndef __LIKE_IO_H
#define __LIKE_IO_H

#include "globals.h"

#define MIN_POWELL 0
#define MIN_SIMPOW 1
#define MIN_AMOEBA 2

void read_like_params(int *sparseflag, int *maximise_flag, 
		      int *hessian_flag, int *galflag,
		      int *saveflag, char outputfn[], int *restart,
		      int rank, int npe);
void fread_like_params(char filename[], int *sparseflag, 
		       int *maximise_flag, int *hessian_flag, int *galflag, 
		       int *saveflag, char outputfn[], int *restart, 
		       int rank, int npe);
void read_lfcn_params(int *plotflag, int *outflag, char *outputfn,
		      int *sparseflag, int *converge, int *saveflag, 
		      int rank, int npe);
void fread_lfcn_params(char filename[],
		       int *plotflag, int *outflag, char *outputfn,
		       int *sparseflag, int *converge, int *saveflag, 
		       int rank, int npe);
void read_beam_info(int *gaussian_beam,
		    char beamfn[], double *beamcell, double *beamfreq);
void read_lim(double *cpsmin, double *cpsmax, double *cpsstep, int *ncps,
	      double *gpsmin, double *gpsmax, double *gpsstep, int *ngps,
	      double *spmin, double *spmax, double *spstep, int *nsp, 
	      int *galflag, int rank, int npe);
void fread_lim(char filename[],
	       double *cpsmin, double *cpsmax, double *cpsstep, int *ncps,
	       double *gpsmin, double *gpsmax, double *gpsstep, int *ngps,
	       double *spmin, double *spmax, double *spstep, int *nsp, 
	       int *galflag, int rank, int npe);
void read_initial_ps(double *cps1dinit, double *gps1dinit, double *sp,
		     int na, int galflag, int *read_ps_flag, 
		     int rank, int npe);
void fread_initial_ps(char filename[],
		      double *cps1dinit, double *gps1dinit, double *sp,
		      int na, int galflag, int *read_ps_flag, 
		      int rank, int npe);
void read_inps(int *nf, double *freq, double *freq0, int *ni, int *fieldn,
	       double *ra, double *dec, double *ra_ref, double *dec_ref,
	       double *sigma, double *antwdth,
	       double *antmax, char datafn[NFMAX+1][FILENAME_LEN], 
	       int rank, int npe);
void fread_inps(char infile[], int *nf, double *freq, double *freq0,
		int *ni, int *fieldn,
		double *ra, double *dec, double *ra_ref, double *dec_ref,
		double *sigma, double *antwdth, double *antmax,
		char datafn[NFMAX+1][FILENAME_LEN], 
		int rank, int npe);
void uvlimits(int nf, char datafn[NFMAX+1][FILENAME_LEN], int *nv,
	      double *uvmin, double *uvmax, int rank, int npe);
void fannuli(char filename[], double uvmin, double uvmax, double antmax, 
	     double *r, int *na, int rank, int npe);
void annuli(double uvmin, double uvmax, double antmax, double *r, int *na,
	    int rank, int npe);
void read_data(int nf, int *freqn, double *u, double *v, double *w,
	       double *visr, double *visi, double *rms, int *nvmax,
	       double *freq, double umin, double umax, 
	       char datafn[NFMAX+1][FILENAME_LEN], 
	       int rank, int npe);
void read_min_params(int *iusemin, int *itol, double *tol, double *lambda,
		     int *itmax, int rank, int npe);
void fread_min_params(char filename[],
		      int *iusemin, int *itol, double *tol, double *lambda,
		      int *itmax, int rank, int npe);
int log_file(char filename[], char error_text[]);
void write_like(char outputfn[FILENAME_LEN], double *ra, int na, 
		double cpsmin, double cpsmax, int ncps,
		double gpsmin, double gpsmax, int ngps,
		double spmin, double spmax, int nsp, double *likeval,
		int rank, int npe);
void read_like(char outputfn[FILENAME_LEN], double *rbins, int na, 
	       double cpsmin, double cpsmax, int ncps,
	       double gpsmin, double gpsmax, int ngps,
	       double spmin, double spmax, int nsp, double *likeval,
	       int rank, int npe);
int read_param_log(char logfile[], double *cps1d, double *gps1d, double *sp, 
		   double *rbins, int na, int galflag, int *iter, int *ibin,
		   int rank, int npe);
int write_param_log(char logfile[], double *cps1d, double *gps1d, double sp,
		    double *rbins, int na, int galflag, int iter, int ibin,
		    int rank, int npe);
#endif
