/*  Time-stamp: <22 May 2002 20:06 BST my_malloc2.h maising> */

#ifndef __MY_MALLOC2_H
#define __MY_MALLOC2_H

#include <stddef.h>
#define C_OFFSET 1

void myerror(char error_text[]);
void warning(char error_text[]);
int write_file(char filename[], char new_text[]);
int debug(char filename[], char error_text[]);

void print_1imatrix(int *t, int n1);
void print_1fmatrix(float *t, int n1);
void print_2fmatrix(float **t, int n1, int n2);
void print_1dmatrix(double *t, int n1);
void print_2dmatrix(double **t, int n1, int n2);
void print_3dmatrix(double ***t, int n1, int n2, int n3);
void print_4dmatrix(double ****t, int n1, int n2, int n3, int n4);
void print_5dmatrix(double *****t, int n1, int n2, int n3, int n4, int n5);
void print_6dmatrix(double ******t, int n1, int n2, int n3, int n4, int n5, int n6);

void *malloc_1matrix(int n1, size_t size);
void **malloc_2matrix(int n1, int n2, size_t size);
void ***malloc_3matrix(int n1, int n2, int n3, size_t size);
void ****malloc_4matrix(int n1, int n2, int n3, int n4, size_t size);

void free_1matrix(void *m, size_t size);
void free_2matrix(void **m, size_t size);
void free_3matrix(void ***m, size_t size);
void free_4matrix(void ****m, size_t size);

float *malloc_1fmatrix(int n);
float **malloc_2fmatrix(int n1, int n2);
float ***malloc_3fmatrix(int n1, int n2, int n3);
float ****malloc_4fmatrix(int n1, int n2, int n3, int n4);

void free_1fmatrix(float *m);
void free_2fmatrix(float **m);
void free_3fmatrix(float ***m);
void free_4fmatrix(float ****m);

double *malloc_1dmatrix(int n);
double **malloc_2dmatrix(int n1, int n2);
double ***malloc_3dmatrix(int n1, int n2, int n3);
double ****malloc_4dmatrix(int n1, int n2, int n3, int n4);
double *****malloc_5dmatrix(int n1, int n2, int n3, int n4, int n5);
double ******malloc_6dmatrix(int n1, int n2, int n3, int n4, int n5, int n6);

void free_1dmatrix(double *m);
void free_2dmatrix(double **m);
void free_3dmatrix(double ***m);
void free_4dmatrix(double ****m);
void free_5dmatrix(double *****m);
void free_6dmatrix(double ******m);

int *malloc_1imatrix(int n);
int **malloc_2imatrix(int n1, int n2);
void free_1imatrix(int *m);
void free_2imatrix(int **m);

void init_mymalloc();
void done_mymalloc();
void reg_dmalloc(int num);
void reg_imalloc(int num);
#endif
