/* CAUTION: This is the ANSI C (only) version of the Numerical Recipes
   utility file nr.h.  Do not confuse this file with the same-named
   file nr.h that is supplied in the 'misc' subdirectory.
   *That* file is the one from the book, and contains both ANSI and
   traditional K&R versions, along with #ifdef macros to select the
   correct version.  *This* file contains only ANSI C.               */

#ifndef __NRMINIMIZER2_H_
#define __NRMINIMIZER2_H_

#include <stdio.h>

void xamoeba(double **p, double y[], int ndim, double ftol,
	double (*funk)(double []), int *iter, int itol);
double xamotry(double **p, double y[], double psum[], int ndim,
	double (*funk)(double []), int ihi, double fac);
void xanneal(double x[], double y[], int iorder[], int ncity);
double xbrent(double ax, double bx, double cx,
	double (*f)(double), double tol, double *xmin);
double xdbrent(double ax, double bx, double cx,
	double (*f)(double), double (*df)(double), double tol, double *xmin);
double xdf1dim(double x);
void xdlinmin(double p[], double xi[], int n, double *fret,
	double (*func)(double []), void (*dfunc)(double [], double[]));
double xdpythag(double a, double b);
double xf1dim(double x);
void xlinmin(double p[], double xi[], int n, double tol, double *fret,
	double (*func)(double []));
void xmnbrak(double *ax, double *bx, double *cx, double *fa, double *fb,
	double *fc, double (*func)(double));
void xpowell(double p[], double **xi, int n, double ftol, int *iter, int itmax, double *fret, int itol,
	double (*func)(double []));
void xfrprmn(double p[], int n, double ftol, int *iter, double *fret,
	double (*func)(double []), void (*dfunc)(double [], double []));

#endif /* _NR_H_ */
