/*
 * routines to read parameters from text file, identified by keywords
 */

/*  Time-stamp: <30 Oct 2002 18:06 GMT params2.c maising> */
/*
 * HISTORY
 *   20/ 2/2001 KSM  Created file
 *   29/11/2001 KSM  adapted to read second argument
 */

#include <stdio.h>
#include <string.h>

static FILE *f_param_file;

/*
 * open file for read access
 */
int open_param_file(char filename[])
{
  f_param_file = fopen(filename, "r");
  if (f_param_file != NULL)
    return 0;
  else
    return -1;
}

/*
 * close the current parameter file
 */
int close_param_file()
{
  if (f_param_file == NULL)
    return -2;
  return fclose(f_param_file);
}

/*
 * read 3 parameterw in double precision
 */
int fget_param_deg(double *deg, double *min, double *sec, char keyword[])
{
  char input_line[255], dummy[255];

  rewind(f_param_file);
  while (fgets(input_line, 250, f_param_file) != NULL) {
    if (strstr(input_line, keyword) != NULL) {
      if (sscanf(input_line, "%s %lf %lf %lf", dummy, deg, min, sec))
	return 0;
    }
  }
  return -1;
}
/*
 * read parameter in double precision
 */
int fget_param_double(double *param, char keyword[])
{
  char input_line[255], dummy[255];

  rewind(f_param_file);
  while (fgets(input_line, 250, f_param_file) != NULL) {
    if (strstr(input_line, keyword) != NULL) {
      if (sscanf(input_line, "%s %lf", dummy, param))
	return 0;
    }
  }
  return -1;
}

/*
 * read parameter in single precision
 */
int fget_param_float(float *param, char keyword[])
{
  char input_line[255], dummy[255];

  rewind(f_param_file);
  while (fgets(input_line, 250, f_param_file) != NULL) {
    if (strstr(input_line, keyword) != NULL) {
      if (sscanf(input_line, "%s %f", dummy, param))
	return 0;
    }
  }
  return -1;
}

/*
 * read integer parameter
 */
int fget_param_int(int *param, char keyword[])
{
  char input_line[255], dummy[255];

  rewind(f_param_file);
  while (fgets(input_line, 250, f_param_file) != NULL) {
    if (strstr(input_line, keyword) != NULL) {
      if (sscanf(input_line, "%s %i", dummy, param))
	return 0;
    }
  }
  return -1;
}

/*
 * read character parameter
 */
int fget_param_char(char *param, char keyword[])
{
  extern FILE *f_param_file;
  char input_line[255], dummy[255];

  rewind(f_param_file);
  while (fgets(input_line, 250, f_param_file) != NULL) {
    if (strstr(input_line, keyword) != NULL) {
      if (sscanf(input_line, "%s %c", dummy, param))
	return 0;
    }
  }
  return -1;
}
/*
 * read string parameter
 */
int fget_param_string(char *param, char keyword[])
{
  char input_line[255], dummy[255];

  rewind(f_param_file);
  while (fgets(input_line, 250, f_param_file) != NULL) {
    if (strstr(input_line, keyword) != NULL) {
      if (sscanf(input_line, "%s %s", dummy, param))
	return 0;
    }
  }
  return -1;
}

int get_param_float(float *param, char txt[])
{
  int status;

  printf("%s", txt);
  status =  scanf("%f", param);
  getchar();
  return (status ? 0 : -1);
}

int get_param_double(double *param, char txt[])
{
  int status;

  printf("%s", txt);
  status = scanf("%lf", param);
  getchar();
  return (status ? 0 : -1);
}

int get_param_int(int *param, char txt[])
{
  int status; 

  printf("%s", txt);
  status = scanf("%i", param);
  getchar();
  return (status ? 0 : -1);
}

int get_param_long(long *param, char txt[])
{
  int status; 

  printf("%s", txt);
  status = scanf("%li", param);
  getchar();
  return (status ? 0 : -1);
}

int get_param_char(char *param, char txt[])
{
  int status;

  printf("%s", txt);
  status = scanf("%c", param);
  getchar();
  return (status ? 0 : -1);
}

int get_param_string(char *param, char txt[])
{
  int status;

  printf("%s", txt);
  status = scanf("%s", param);
  getchar();
  return (status ? 0 : -1);
}

int get_param_filename(char param[], char txt[], char rwmode[])
{
  FILE *fp;
  int status;

  do {
    printf("%s", txt);
    status = scanf("%s", param);
    getchar();
    fp = fopen(param, rwmode);
    if (! fp)
      printf("  Error opening %s.\n", param);

  } while (!fp);
  fclose(fp);

  return (status ? 0 : -1);
}
